NDSummary.OnToolTipsLoaded("CClass:NodeEepromHelper",{1967:"<div class=\"NDToolTip TClass LC\"><div class=\"NDClassPrototype\" id=\"NDClassPrototype1967\"><div class=\"CPEntry TClass Current\"><div class=\"CPName\">NodeEepromHelper</div></div></div><div class=\"TTSummary\">A helper class for reading and writing to a Wireless Node\'s Eeprom.&nbsp; This class provides eeprom specific parsing so that high-level objects can be converted to their low-level eeprom value equivelent and vice-versa.</div></div>",1978:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1978\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">NodeEepromHelper(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">WirelessNode_Impl&nbsp;</td><td class=\"PNamePrefix\">*</td><td class=\"PName last\">node</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Creates a NodeEepromHelper object with a WirelessNode_Impl.</div></div>",1980:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1980\" class=\"NDPrototype NoParameterForm\">WirelessNode_Impl* m_node</div><div class=\"TTSummary\">The WirelessNode_Impl used by this eeprom helper.</div></div>",1982:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1982\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">Value read(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">EepromLocation&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">location</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads an EepromLocation from the Node and returns a Value with the result.</div></div>",1983:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1983\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">EepromLocation&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">location,</td></tr><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">Value&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">val</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes a Value to a given EepromLocation on the Node.</div></div>",1984:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1984\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint16</span> nodeAddress() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the node address for this Node.</div></div>",1985:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1985\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">void</span> applyEepromChanges()</div><div class=\"TTSummary\">Resets the radio/power on the Node to apply eeprom changes that have been made.</div></div>",1986:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1986\" class=\"NDPrototype NoParameterForm\">WirelessTypes::Frequency read_frequency() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the frequency from the Node.</div></div>",1987:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1987\" class=\"NDPrototype NoParameterForm\">WirelessTypes::RegionCode read_regionCode() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the region code from the Node.</div></div>",1988:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1988\" class=\"NDPrototype NoParameterForm\">Version read_fwVersion() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the firmware version of the Node.</div></div>",1989:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1989\" class=\"NDPrototype NoParameterForm\">WirelessModels::NodeModel read_model() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the model of the Node.</div></div>",1990:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1990\" class=\"NDPrototype NoParameterForm\">std::<span class=\"SHKeyword\">string</span> read_serial() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the serial number of the Node.</div></div>",1991:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1991\" class=\"NDPrototype NoParameterForm\">WirelessTypes::MicroControllerType read_microcontroller() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the microcontroller of the Node.</div></div>",1992:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1992\" class=\"NDPrototype NoParameterForm\">RadioFeatures read_radioFeatures() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the RadioFeatures of the Node.</div></div>",1993:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1993\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint64</span> read_dataStorageSize() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the total number of bytes available for data storage on the Node.&nbsp; This is an overall count and does not take into account data that is already stored on the Node.</div></div>",1994:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1994\" class=\"NDPrototype NoParameterForm\">WirelessTypes::SettlingTime read_filter1() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the specific filter 1 eeprom location.&nbsp; Note: this should be used by the SyncSamplingNetwork only, as it bypasses the ChannelMask logic.</div></div>",1995:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1995\" class=\"NDPrototype NoParameterForm\">WirelessTypes::SettlingTime read_filter2() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the specific filter 2 eeprom location.&nbsp; Note: this should be used by the SyncSamplingNetwork only, as it bypasses the ChannelMask logic.</div></div>",1996:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1996\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_channelMask(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">channels</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the channel mask to the Node, representing which channels are active or not.</div></div>",1997:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1997\" class=\"NDPrototype NoParameterForm\">ChannelMask read_channelMask() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the current channel mask from the Node, representing which channels are active or not.</div></div>",1998:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1998\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_numSweeps(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint32</span>&nbsp;</td><td class=\"PName last\">sweeps</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the number of sweeps which affects the duration of sampling. In the case of Burst sampling, this is the number of sweeps per burst This function assumes the number of sweeps has already been normalized (multiple of 100 and within min/max).</div></div>",1999:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1999\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint32</span> read_numSweeps() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the current number of sweeps which affects the duration of sampling.</div></div>",2000:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2000\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_unlimitedDuration(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">bool</span>&nbsp;</td><td class=\"PName last\">unlimitedDuration,</td></tr><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">SamplingMode&nbsp;</td><td class=\"PName last\">samplingMode</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the unlimited duration flag. This is a different eeprom location depending on the sampling mode.</div></div>",2001:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2001\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> read_unlimitedDuration(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">SamplingMode&nbsp;</td><td class=\"PName last\">samplingMode</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the current unlimited duration flag set on the Node. This is a different eeprom location depending on the sampling mode.</div></div>",2002:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2002\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_sampleRate(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">WirelessSampleRate&nbsp;</td><td class=\"PName last\">rate,</td></tr><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">SamplingMode&nbsp;</td><td class=\"PName last\">samplingMode</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the sample rate. This is a different eeprom location depending on the sampling mode.</div></div>",2003:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2003\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">WirelessTypes::WirelessSampleRate read_sampleRate(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">SamplingMode&nbsp;</td><td class=\"PName last\">samplingMode</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the current sample rate set on the Node. This is a different eeprom location depending on the sampling mode.</div></div>",2004:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2004\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_dataFormat(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">DataFormat&nbsp;</td><td class=\"PName last\">dataFormat</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the data format to the Node.</div></div>",2005:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2005\" class=\"NDPrototype NoParameterForm\">WirelessTypes::DataFormat read_dataFormat() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the current data format set on the Node.</div></div>",2006:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2006\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_collectionMode(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">DataCollectionMethod&nbsp;</td><td class=\"PName last\">collectionMode</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the data collection mode to the Node.</div></div>",2007:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2007\" class=\"NDPrototype NoParameterForm\">WirelessTypes::DataCollectionMethod read_collectionMode() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the current data collection mode set on the Node.</div></div>",2008:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2008\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_syncSamplingMode(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">SyncSamplingMode&nbsp;</td><td class=\"PName last\">syncMode</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the sync sampling mode to the Node.</div></div>",2009:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2009\" class=\"NDPrototype NoParameterForm\">WirelessTypes::SyncSamplingMode read_syncSamplingMode() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the current sync sampling mode set on the Node.</div></div>",2010:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2010\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_samplingDelay(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">TimeSpan&nbsp;</td><td class=\"PName last\">delay</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the sampling delay to the Node.</div></div>",2011:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2011\" class=\"NDPrototype NoParameterForm\">TimeSpan read_samplingDelay() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the current sampling delay set on the Node.</div></div>",2012:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2012\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_retransmission(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">NodeRetransmission&nbsp;</td><td class=\"PName last\">reTx</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the retransmission option to the Node.</div></div>",2013:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2013\" class=\"NDPrototype NoParameterForm\">WirelessTypes::NodeRetransmission read_retransmission() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the current retransmission option set on the Node.</div></div>",2014:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2014\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_settlingTime(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask,</td></tr><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">SettlingTime&nbsp;</td><td></td><td class=\"PName last\">settlingTime</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the settling time to the Node for the given ChannelMask.</div></div>",2015:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2015\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">WirelessTypes::SettlingTime read_settlingTime(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the current filter settling time on the Node for the given ChannelMask.</div></div>",2016:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2016\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_timeBetweenBursts(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">TimeSpan&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">timespan</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the time between each burst to the Node.&nbsp; This function assumes the time between bursts value has been normalized.</div></div>",2017:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2017\" class=\"NDPrototype NoParameterForm\">TimeSpan read_timeBetweenBursts() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the time between each burst from the Node.</div></div>",2018:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2018\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_samplingMode(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">SamplingMode&nbsp;</td><td class=\"PName last\">samplingMode</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the WirelessTypes::SamplingMode to the Node.</div></div>",2019:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2019\" class=\"NDPrototype NoParameterForm\">WirelessTypes::SamplingMode read_samplingMode() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the current WirelessTypes::SamplingMode from the Node.</div></div>",2020:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2020\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_channelLinearEquation(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask,</td></tr><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">LinearEquation&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">equation</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the slope and offset for the specified ChannelMask on the Node.</div></div>",2021:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2021\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> read_channelLinearEquation(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask,</td></tr><tr><td class=\"first\"></td><td class=\"PType\">LinearEquation&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">result</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Reads the slope and offset for the specified ChannelMask from the Node.</div></div>",2022:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2022\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_channelUnit(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask,</td></tr><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">CalCoef_Unit&nbsp;</td><td></td><td class=\"PName last\">unit</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the unit for the specified ChannelMask to the Node.</div></div>",2023:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2023\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_channelEquation(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask,</td></tr><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">CalCoef_EquationType&nbsp;</td><td></td><td class=\"PName last\">equation</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the equation id for the specified ChannelMask to the Node.</div></div>",2024:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2024\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_channelUnitAndEquation(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask,</td></tr><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">CalCoef_Unit&nbsp;</td><td></td><td class=\"PName last\">unit,</td></tr><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">CalCoef_EquationType&nbsp;</td><td></td><td class=\"PName last\">equation</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the unit and equation for the specified ChannelMask to the Node.</div></div>",2025:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2025\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">WirelessTypes::CalCoef_Unit read_channelUnit(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the WirelessTypes::CalCoef_Unit for the specified ChannelMask from the Node.</div></div>",2026:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2026\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">WirelessTypes::CalCoef_EquationType read_channelEquation(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the WirelessTypes::CalCoef_EquationType for the specified channel from the Node.&nbsp; This assumes the channel is supported by the Node.</div></div>",2027:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2027\" class=\"NDPrototype NoParameterForm\">WirelessTypes::TransmitPower read_transmitPower() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the WirelessTypes::TransmitPower that is currently set on the Node.</div></div>",2028:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2028\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_transmitPower(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">TransmitPower&nbsp;</td><td class=\"PName last\">power</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the WirelessTypes::TransmitPower to the Node.</div></div>",2029:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2029\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint16</span> read_inactivityTimeout() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the user inactivity timeout that is currently set on the Node.&nbsp; This controls how many seconds before the Node goes to sleep when idle.</div></div>",2030:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2030\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_inactivityTimeout(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">timeout</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the user inactivity timeout to the Node.&nbsp; This function assumes the inactivity timeout has already been set to be above the minimum.</div></div>",2031:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2031\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint8</span> read_checkRadioInterval() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the check radio interval that is currently set on the Node.&nbsp; This controls how often the node wakes up from sleep to check for commands.</div></div>",2032:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2032\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_checkRadioInterval(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint8</span>&nbsp;</td><td class=\"PName last\">interval</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the check radio interval to the Node.&nbsp; This controls how often the node wakes up from sleep to check for commands.&nbsp; This function assumes the interval is within the acceptable range.</div></div>",2033:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2033\" class=\"NDPrototype NoParameterForm\">WirelessTypes::DefaultMode read_defaultMode() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the WirelessTypes::DefaultMode that is currently set on the Node.</div></div>",2034:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2034\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_defaultMode(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">DefaultMode&nbsp;</td><td class=\"PName last\">mode</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the given WirelessTypes::DefaultMode to the Node.</div></div>",2035:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2035\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint16</span> read_logPage() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the next flash page that to be used for datalogging.</div></div>",2036:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2036\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint16</span> read_logPageOffset() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the byte offset into the log page for the next datalogging session.</div></div>",2037:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2037\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint16</span> read_numDatalogSessions() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the number of datalog sessions that are currently stored on the Node.</div></div>",2038:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2038\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_txPerGroup(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">txPerGroup</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the transmissions per group to the Node.</div></div>",2039:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2039\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_groupSize(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">groupSize</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the group size to the Node.</div></div>",2040:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2040\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_tdmaAddress(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">address</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the TDMA address to the Node.</div></div>",2041:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2041\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_maxRetransPerBurst(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">maxReTxPerBurst</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the max retransmissions per burst to the Node.</div></div>",2042:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2042\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">double</span> read_hardwareGain(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the hardware gain for the specified ChannelMask from the Node.</div></div>",2043:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2043\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">uint16</span> read_hardwareOffset(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the hardware offset for the specified ChannelMask from the Node.</div></div>",2044:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2044\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_hardwareGain(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">double</span>&nbsp;</td><td></td><td class=\"PName last\">gain</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the hardware gain value for the specified ChannelMask to the Node.</div></div>",2045:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2045\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_hardwareOffset(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td></td><td class=\"PName last\">offset</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the hardware offset value for the specified ChannelMask to the Node.</div></div>",2046:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2046\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">float</span> read_gaugeFactor(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the gauge factor for the specified ChannelMask from the Node.</div></div>",2047:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2047\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_gaugeFactor(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">float</span>&nbsp;</td><td></td><td class=\"PName last\">gaugeFactor</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the gauge factor value for the specified ChannelMask to the Node.</div></div>",2048:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2048\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">WirelessTypes::ThermocoupleType read_thermoType(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the WirelessTypes::ThermocoupleType from the Node.</div></div>",2049:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2049\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_thermoType(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ChannelMask&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">mask,</td></tr><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">ThermocoupleType&nbsp;</td><td></td><td class=\"PName last\">thermocouple</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the WirelessTypes::ThermocoupleType to the Node.&nbsp; This assumes thermocouple type is supported.</div></div>",2050:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2050\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> read_activitySense(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">ActivitySense&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">result</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the ActivitySense options from the Node.&nbsp; This assumes activity sense configuration is supported by the Node.</div></div>",2051:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2051\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_activitySense(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ActivitySense&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">options</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the ActivitySense options to the Node.&nbsp; This assumes fatigue options configuration is supported by the Node.</div></div>",2052:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2052\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> read_fatigueOptions(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">FatigueOptions&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">result</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the FatigueOptions from the Node.&nbsp; This assumes fatigue options configuration is supported by the Node.</div></div>",2053:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2053\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_fatigueOptions(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">FatigueOptions&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">options</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the FatigueOptions to the Node.&nbsp; This assumes fatigue options configuration is supported by the Node.</div></div>",2054:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2054\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> read_histogramOptions(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">HistogramOptions&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">result</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the HistogramOptions from the Node.&nbsp; This assumes histogram options configuration is supported by the Node.</div></div>",2055:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2055\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_histogramOptions(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">HistogramOptions&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">options</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the HistogramOptions to the Node.&nbsp; This assumes histogram options configuration is supported by the Node and all options are valid.</div></div>",2056:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2056\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">void</span> clearHistogram()</div><div class=\"TTSummary\">Clears the Histogram on the Node.&nbsp; This assumes histogram options configuration is supported by the Node.</div></div>",2057:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2057\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint16</span> read_lostBeaconTimeout() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the lost beacon timeout value from the Node.&nbsp; A value of 0 means the timeout is disabled.&nbsp; This assumes lost beacon timeout is supported by the Node.</div></div>",2058:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype2058\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> write_lostBeaconTimeout(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">minutes</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the lost beacon timeout value, in minutes, to the Node.&nbsp; This assumes the value is within range of a valid value.</div></div>"});