NDSummary.OnToolTipsLoaded("File:MicroStrain/Inertial/InertialNode_Impl.h",{1049:"<div class=\"NDToolTip TClass LC\"><div class=\"NDClassPrototype\" id=\"NDClassPrototype1049\"><div class=\"CPEntry TClass Current\"><div class=\"CPName\">InertialNode_Impl</div></div></div><div class=\"TTSummary\">Contains the implementation for an InertialNode.</div></div>",1051:"<div class=\"NDToolTip TConstant LC\"><div class=\"TTSummary\">The default timeout for Inertial commands (100 milliseconds)</div></div>",1053:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1053\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">explicit</span> InertialNode_Impl(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">Connection&nbsp;</td><td class=\"PName last\">connection</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Creates an InertialNode_Impl object.</div></div>",1054:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1054\" class=\"NDPrototype NoParameterForm\">~InertialNode_Impl()</div><div class=\"TTSummary\">Destroys the InertialNode object</div></div>",1056:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1056\" class=\"NDPrototype NoParameterForm\">Connection m_connection</div><div class=\"TTSummary\">The Connection object used for communication</div></div>",1057:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1057\" class=\"NDPrototype NoParameterForm\">InertialPacketCollector m_packetCollector</div><div class=\"TTSummary\">The Inertial packet collector used to store interial data packets</div></div>",1058:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1058\" class=\"NDPrototype NoParameterForm\">std::shared_ptr&lt;ResponseCollector&gt; m_responseCollector</div><div class=\"TTSummary\">The response collector used to find and store wireless command responses</div></div>",1059:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1059\" class=\"NDPrototype NoParameterForm\">std::unique_ptr&lt;InertialParser&gt; m_parser</div><div class=\"TTSummary\">The Inertial parser in charge of parsing all incoming data to this device</div></div>",1060:"<div class=\"NDToolTip TVariable LC\"><div class=\"TTSummary\">The timeout to use for Inertial commands</div></div>",1061:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1061\" class=\"NDPrototype NoParameterForm\">std::unique_ptr&lt;InertialNodeInfo&gt; m_nodeInfo</div><div class=\"TTSummary\">The InertialNodeInfo object that gives access to information of the Inertial Node</div></div>",1062:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1062\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint16</span> m_sensorRateBase</div><div class=\"TTSummary\">The Sensor sample rate base (if any).</div></div>",1063:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1063\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint16</span> m_gpsRateBase</div><div class=\"TTSummary\">The GPS sample rate base (if any).</div></div>",1064:"<div class=\"NDToolTip TVariable LC\"><div class=\"TTSummary\">The Estimation Filter sample rate base (if any).</div></div>",1065:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1065\" class=\"NDPrototype NoParameterForm\">SampleRates m_sensorSampleRates</div><div class=\"TTSummary\">Contains the sample rates for the Sensor group.</div></div>",1066:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1066\" class=\"NDPrototype NoParameterForm\">SampleRates m_gpsSampleRates</div><div class=\"TTSummary\">Contains the sample rates for the GPS group.</div></div>",1067:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1067\" class=\"NDPrototype NoParameterForm\">SampleRates m_estfilterSampleRates</div><div class=\"TTSummary\">Contains the sample rates for the Estimation Filter group.</div></div>",1068:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1068\" class=\"NDPrototype NoParameterForm\">Timestamp m_lastCommTime</div><div class=\"TTSummary\">A Timestamp representing the last time communication was achieved with the InertialNode.</div></div>",1069:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1069\" class=\"NDPrototype NoParameterForm\">std::unique_ptr&lt;InertialNodeFeatures&gt; m_features</div><div class=\"TTSummary\">The InertialNodeFeatures containing the features for this device.</div></div>",1071:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1071\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> parseResponse(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">DataBuffer&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">data</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Callback function that parses any bytes that are in the read buffer to find packets or command responses</div></div>",1072:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1072\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual</span> GenericInertialCommandResponse doInertialCmd(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">GenericInertialCommand::</td><td class=\"PType\">Response&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName\">response,</td><td></td><td class=\"last\"></td></tr><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ByteStream&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName\">command,</td><td></td><td class=\"last\"></td></tr><tr><td class=\"PModifierQualifier first\">InertialTypes::</td><td class=\"PType\">Command&nbsp;</td><td></td><td class=\"PName\">commandId,</td><td></td><td class=\"last\"></td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">bool</span>&nbsp;</td><td></td><td class=\"PName\">verifySupported&nbsp;</td><td class=\"PDefaultValueSeparator\">=&nbsp;</td><td class=\"PDefaultValue last\"><span class=\"SHKeyword\">true</span></td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs a generic Inertial Command, sending the command bytes and waiting for the response.</div></div>",1073:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1073\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">const</span> InertialNodeInfo&amp; info()</div><div class=\"TTSummary\">Gets the InertialNodeInfo for this Node.&nbsp; The first time this function is called, it will send multiple commands to the device to get all required information.</div></div>",1074:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1074\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual const</span> InertialNodeFeatures&amp; features()</div><div class=\"TTSummary\">Gets a reference to the InertialNodeFeatures for this device.</div></div>",1075:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1075\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">const</span> Timestamp&amp; lastCommunicationTime() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the Timestamp for the last time we communicated with the InertialNode.</div></div>",1076:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1076\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">const</span> SampleRates&amp; supportedSampleRates(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">InertialTypes::</td><td class=\"PType\">InertialCategory&nbsp;</td><td class=\"PName last\">category</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Gets a list of the supported sample rates for an InertialTypes::InertialCategory.</div></div>",1077:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1077\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> getDataPackets(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">std::</td><td class=\"PType\">vector&lt;InertialDataPacket&gt;&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName\">packets,</td><td></td><td class=\"last\"></td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">uint32</span>&nbsp;</td><td></td><td class=\"PName\">timeout&nbsp;</td><td class=\"PDefaultValueSeparator\">=&nbsp;</td><td class=\"PDefaultValue last\"><span class=\"SHNumber\">0</span>,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">uint32</span>&nbsp;</td><td></td><td class=\"PName\">maxPackets&nbsp;</td><td class=\"PDefaultValueSeparator\">=&nbsp;</td><td class=\"PDefaultValue last\"><span class=\"SHNumber\">0</span></td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Gets up to the requested amount of data packets that have been collected.</div></div>",1078:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1078\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint32</span> totalPackets()</div><div class=\"TTSummary\">Gets the total number of data packets that are currently in the buffer.</div></div>",1079:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1079\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> timeout(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint64</span>&nbsp;</td><td class=\"PName last\">timeout</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sets the timeout to use when waiting for responses from Inertial commands.</div></div>",1080:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1080\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint64</span> timeout()</div><div class=\"TTSummary\">Gets the timeout to use when waiting for responses from Inertial commands.</div></div>",1081:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1081\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual</span> InertialDeviceInfo getDeviceInfo()</div><div class=\"TTSummary\">Gets information about the InertialNode.&nbsp; Sends the &quot;Get Device Information&quot; command to the device.</div></div>",1082:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1082\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual</span> std::vector&lt;<span class=\"SHKeyword\">uint16</span>&gt; getDescriptorSets()</div><div class=\"TTSummary\">Gets the supported descriptor sets for this node, representing which commands and data sets are available.&nbsp; Sends the &quot;Get Device Descriptor Sets&quot; command to the device.</div></div>",1083:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1083\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">bool</span> ping()</div><div class=\"TTSummary\">Pings the node to check for communication.&nbsp; Sends the &quot;Ping&quot; command to the device.</div></div>",1084:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1084\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">void</span> setToIdle()</div><div class=\"TTSummary\">Suspends streaming (if enabled) or wakes the device from sleep (if sleeping), putting the device in an idle mode.&nbsp; After this command is used, the resume command may be used to put the Node back into the mode it was previously in before setToIdle was called.</div></div>",1085:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1085\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">void</span> resume()</div><div class=\"TTSummary\">Places the Node back in the mode it was in before issuing the setToIdle command.&nbsp; If the setToIdle command was not issues, then the device is placed in default mode.</div></div>",1086:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1086\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual uint16</span> getDataRateBase(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">InertialTypes::</td><td class=\"PType\">InertialCategory&nbsp;</td><td class=\"PName last\">category</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Gets the Data decimation base for the data rate calculations of the specified InertialTypes::InertialCategory.</div></div>",1087:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1087\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual</span> InertialChannels getMessageFormat(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">InertialTypes::</td><td class=\"PType\">InertialCategory&nbsp;</td><td class=\"PName last\">category</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Gets the current message format of the specified InertialTypes::InertialCategory\'s data packet.</div></div>",1088:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1088\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual void</span> setMessageFormat(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">InertialTypes::</td><td class=\"PType\">InertialCategory&nbsp;</td><td></td><td class=\"PName last\">category,</td></tr><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">InertialChannels&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">channels</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sets the current message format of the specified InertialTypes::InertialCategory\'s data packet.&nbsp; Note that this function does not add to the existing message format, but overwrites it entirely.</div></div>",1089:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1089\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual uint8</span> getCommunicationMode()</div><div class=\"TTSummary\">Gets the current communication mode that the node is in.</div></div>",1090:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1090\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual void</span> setCommunicationMode(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint8</span>&nbsp;</td><td class=\"PName last\">communicationMode</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sets the communication mode for the node.&nbsp; Note: The node info will be reset when doing this and therefore will require being fetched again the next time it is requested.</div></div>",1091:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1091\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> enableDataStream(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">InertialTypes::</td><td class=\"PType\">InertialCategory&nbsp;</td><td class=\"PName last\">category,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">bool</span>&nbsp;</td><td class=\"PName last\">enable</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Enables or disables continuous data streaming for the node.</div></div>",1092:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1092\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">void</span> resetFilter()</div><div class=\"TTSummary\">Resets the filter to the initialize state.</div></div>",1093:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1093\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">bool</span> getAutoInitialization()</div><div class=\"TTSummary\">Gets the state of the automatic initialization upon device startup.</div></div>",1094:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1094\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> setAutoInitialization(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">bool</span>&nbsp;</td><td class=\"PName last\">enable</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sets the state of the automatic initialization upon device startup.</div></div>",1095:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1095\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> setInitialAttitude(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">EulerAngles&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">attitude</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sets the initial attitude.</div></div>",1096:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1096\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> setInitialHeading(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">float</span>&nbsp;</td><td class=\"PName last\">heading</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sets the initial heading.</div></div>",1097:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1097\" class=\"NDPrototype NoParameterForm\">EulerAngles getSensorToVehicleTransformation()</div><div class=\"TTSummary\">Gets the sensor to vehicle frame transformation matrix using roll, pitch, and yaw Euler angles (in radians).</div></div>",1098:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1098\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> setSensorToVehicleTransformation(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">EulerAngles&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">angles</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sets the sensor to vehicle frame transformation matrix using roll, pitch, and yaw Euler angles (in radians).</div></div>",1099:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1099\" class=\"NDPrototype NoParameterForm\">PositionOffset getSensorToVehicleOffset()</div><div class=\"TTSummary\">Gets the sensor to vehicle frame offset, expressed in the sensor frame.</div></div>",1100:"<div class=\"NDToolTip TFunction LC\"><div class=\"TTSummary\">Sets the sensor to vehicle frame offset, expressed in the sensor frame.</div></div>",1101:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1101\" class=\"NDPrototype NoParameterForm\">PositionOffset getAntennaOffset()</div><div class=\"TTSummary\">Gets the antenna offset, expressed in the sensor frame.</div></div>",1102:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1102\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> setAntennaOffset(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">PositionOffset&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">offset</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sets the antenna offset, expressed in the sensor frame.</div></div>"});