NDSummary.OnToolTipsLoaded("File:MicroStrain/Wireless/BaseStation_Impl.h",{3878:"<div class=\"NDToolTip TClass LC\"><div class=\"NDClassPrototype\" id=\"NDClassPrototype3878\"><div class=\"CPEntry TClass Current\"><div class=\"CPName\">BaseStation_Impl</div></div></div><div class=\"TTSummary\">Contains the implementation for a BaseStation object.</div></div>",3880:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3880\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">explicit</span> BaseStation_Impl(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">Connection&nbsp;</td><td class=\"PName last\">connection,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint64</span>&nbsp;</td><td class=\"PName last\">baseTimeout</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Creates a BaseStation_Impl object.&nbsp; Note: This will communicate with the BaseStation to get device information, as well as start the data collection thread.</div></div>",3881:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3881\" class=\"NDPrototype NoParameterForm\">~BaseStation_Impl()</div><div class=\"TTSummary\">Destroys the BaseStation object</div></div>",3883:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3883\" class=\"NDPrototype NoParameterForm\">Connection m_connection</div><div class=\"TTSummary\">The Connection object used for communication</div></div>",3884:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3884\" class=\"NDPrototype NoParameterForm\">WirelessPacketCollector m_packetCollector</div><div class=\"TTSummary\">The wireless packet collector used to store wireless data packets</div></div>",3885:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3885\" class=\"NDPrototype NoParameterForm\">std::shared_ptr&lt;ResponseCollector&gt; m_responseCollector</div><div class=\"TTSummary\">The response collector used to find and store wireless command responses</div></div>",3886:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3886\" class=\"NDPrototype NoParameterForm\">std::unique_ptr&lt;WirelessParser&gt; m_parser</div><div class=\"TTSummary\">The wireless parser in charge of parsing all incoming data to this base station</div></div>",3887:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3887\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint64</span> m_baseCommandsTimeout</div><div class=\"TTSummary\">The timeout (in milliseconds) to use for base station commands.</div></div>",3888:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3888\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint64</span> m_nodeCommandsTimeout</div><div class=\"TTSummary\">The timeout (in milliseconds) to use for node commands.</div></div>",3889:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3889\" class=\"NDPrototype NoParameterForm\">mutable WirelessTypes::Frequency m_frequency</div><div class=\"TTSummary\">The last known radio frequency (WirelessTypes::Frequency) that the BaseStation was known to be on</div></div>",3890:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3890\" class=\"NDPrototype NoParameterForm\">mutable std::unique_ptr&lt;BaseStationEeprom&gt; m_eeprom</div><div class=\"TTSummary\">The BaseStationEeprom that handles reading and writing eeprom values with the BaseStation and eeprom cache.</div></div>",3891:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3891\" class=\"NDPrototype NoParameterForm\">mutable std::unique_ptr&lt;BaseStationEepromHelper&gt; m_eepromHelper</div><div class=\"TTSummary\">The BaseStationEepromHelper used for high level eeprom reads and writes on the BaseStation.</div></div>",3892:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3892\" class=\"NDPrototype NoParameterForm\">mutable std::unique_ptr&lt;BaseStationFeatures&gt; m_features</div><div class=\"TTSummary\">The BaseStationFeatures containing the features for this BaseStation.</div></div>",3893:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3893\" class=\"NDPrototype NoParameterForm\">std::unique_ptr&lt;WirelessProtocol&gt; m_protocol</div><div class=\"TTSummary\">The WirelessProtocol containing all of the protocol commands and info for this BaseStation.</div></div>",3894:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3894\" class=\"NDPrototype NoParameterForm\">Timestamp m_lastCommTime</div><div class=\"TTSummary\">A Timestamp representing the last time communication was achieved with the BaseStation.</div></div>",3895:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype3895\" class=\"NDPrototype NoParameterForm\">std::map&lt;NodeAddress, Timestamp&gt; m_nodesLastCommTime</div><div class=\"TTSummary\">A map of NodeAddress to Timestamp objects, holding the last communication time for nodes with this BaseStation.</div></div>",3897:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3897\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">static uint32</span> getTimeForBeacon()</div><div class=\"TTSummary\">Gets the system time in UTC seconds since Unix Epoch as close to 0 milliseconds as possible</div></div>",3898:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3898\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> parseData(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">DataBuffer&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">data</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Callback function that parses any bytes that are in the read buffer to find packets or command responses</div></div>",3899:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3899\" class=\"NDPrototype NoParameterForm\">std::unique_ptr&lt;WirelessProtocol&gt; determineProtocol()</div><div class=\"TTSummary\">Determines the WirelessProtocol to use based on the BaseStation\'s firmware version.</div></div>",3900:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3900\" class=\"NDPrototype NoParameterForm\">BaseStationEepromHelper&amp; eeHelper() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets a reference to the BaseStationEepromHelper for this BaseStation.</div></div>",3901:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3901\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> doCommand(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"first\"></td><td class=\"PType\">ResponsePattern&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">response,</td></tr><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">ByteStream&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">cmdBytes,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">uint64</span>&nbsp;</td><td></td><td class=\"PName last\">timeout</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs a custom command and waits for the response.</div></div>",3902:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3902\" class=\"NDPrototype NoParameterForm\">Connection&amp; connection()</div><div class=\"TTSummary\">Gets the Connection object that this BaseStation is using.</div></div>",3903:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3903\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual const</span> BaseStationFeatures&amp; features() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets a reference to the BaseStationFeatures for this BaseStation.</div></div>",3904:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3904\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual const</span> WirelessProtocol&amp; protocol()</div><div class=\"TTSummary\">Gets a reference to the WirelessProtocol for this BaseStation.&nbsp; Note: This requires communicating to the BaseStation if creating the protocol for the first time.</div></div>",3905:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3905\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">const</span> Timestamp&amp; lastCommunicationTime() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the Timestamp for the last time we communicated with the BaseStation.</div></div>",3906:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3906\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> read(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td></td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">result</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Reads the value from the BaseStation for a specified eeprom location.</div></div>",3907:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3907\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> write(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">value</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes a value to the BaseStation at a specified eeprom location.</div></div>",3908:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3908\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> readWriteRetries(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint8</span>&nbsp;</td><td class=\"PName last\">numRetries</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sets the number of retry attempts for reading and writing with the BaseStation.</div></div>",3909:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3909\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> useEepromCache(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">bool</span>&nbsp;</td><td class=\"PName last\">useCache</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sets whether or not to utilize the eeprom cache when configuring this BaseStation (default of enabled). This can be enabled/disabled at any time.&nbsp; Note:&nbsp; The eeprom cache stores the last known value that was written to / read from the BaseStation for each eeprom location. If this is enabled, any reads will get the last known value from the cache if it exists, and any writes will not write to the BaseStation if the value attempting to be written is the same as that stored in the cache. Caching of these values will still be performed if this is disabled, however, read and write operations will then always reach out to the actual device.</div></div>",3910:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3910\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">void</span> clearEepromCache()</div><div class=\"TTSummary\">Clears the eeprom cache for this BaseStation.</div></div>",3911:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3911\" class=\"NDPrototype NoParameterForm\">WirelessTypes::Frequency frequency() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the WirelessTypes::Frequency representing the radio frequency of this BaseStation.&nbsp; If the frequency is unknown, it will be read from the BaseStation.</div></div>",3912:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3912\" class=\"NDPrototype NoParameterForm\">WirelessTypes::RegionCode regionCode() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the WirelessTypes::RegionCode representing the region of this BaseStation.</div></div>",3913:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3913\" class=\"NDPrototype NoParameterForm\">Version firmwareVersion() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the firmware version of the BaseStation.</div></div>",3914:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3914\" class=\"NDPrototype NoParameterForm\">WirelessModels::BaseModel model() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the model of the BaseStation.</div></div>",3915:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3915\" class=\"NDPrototype NoParameterForm\">std::<span class=\"SHKeyword\">string</span> serial() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the serial number of the BaseStation.</div></div>",3916:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3916\" class=\"NDPrototype NoParameterForm\">WirelessTypes::MicroControllerType microcontroller() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the microcontroller of the BaseStation.</div></div>",3917:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3917\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> getData(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">std::</td><td class=\"PType\">vector&lt;DataSweep&gt;&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName\">sweeps,</td><td></td><td class=\"last\"></td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">uint32</span>&nbsp;</td><td></td><td class=\"PName\">timeout&nbsp;</td><td class=\"PDefaultValueSeparator\">=&nbsp;</td><td class=\"PDefaultValue last\"><span class=\"SHNumber\">0</span>,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">uint32</span>&nbsp;</td><td></td><td class=\"PName\">maxSweeps&nbsp;</td><td class=\"PDefaultValueSeparator\">=&nbsp;</td><td class=\"PDefaultValue last\"><span class=\"SHNumber\">0</span></td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Gets up to the requested amount of DataSweeps of sampled data that was collected by this BaseStation.</div></div>",3918:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3918\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint32</span> totalData()</div><div class=\"TTSummary\">Gets the number of DataSweeps that are currently in the data buffer.</div></div>",3919:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3919\" class=\"NDPrototype NoParameterForm\">NodeDiscoveries getNodeDiscoveries()</div><div class=\"TTSummary\">Gets the group of Node Discoveries that were collected by this base station.&nbsp; Calling this function clears out the Node Discovery buffer, so repeatedly calling this will give you any new Node Discoveries.</div></div>",3920:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3920\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> timeout(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint64</span>&nbsp;</td><td class=\"PName last\">timeout</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sets the timeout to use when waiting for responses from commands.</div></div>",3921:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3921\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint64</span> timeout() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the current timeout to use when waiting for responses from commands.</div></div>",3922:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3922\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint64</span> nodeCommandsTimeout() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the current timeout to use when waiting for responses from node commands</div></div>",3923:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3923\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual bool</span> ping()</div><div class=\"TTSummary\">Pings the base station</div></div>",3924:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3924\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual uint16</span> readEeprom(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">eepromAddress</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads a specific EEPROM address on the BaseStation.&nbsp; If the value stored in the eeprom cache is still valid, this will be returned instead.</div></div>",3925:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3925\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual</span> Value readEeprom(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">EepromLocation&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">location</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads a value from the given EepromLocation of the BaseStation.&nbsp; If the value stored in the eeprom cache is still valid, this will be returned instead.</div></div>",3926:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3926\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual void</span> writeEeprom(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">value</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes the specified uint16 value to a specific EEPROM address on the BaseStation.&nbsp; If successful, the cache will be updated with the changed value as well.</div></div>",3927:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3927\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual void</span> writeEeprom(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">EepromLocation&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">location,</td></tr><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">Value&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">val</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes a value to the given EepromLocation of the BaseStation.&nbsp; If successful, the cache will be updated with the changed value as well.</div></div>",3928:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3928\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual</span> Timestamp enableBeacon()</div><div class=\"TTSummary\">Enables the beacon on the base station using the system time (UTC) as its starting timestamp.</div></div>",3929:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3929\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual</span> Timestamp enableBeacon(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint32</span>&nbsp;</td><td class=\"PName last\">utcTime</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Enables the beacon on the base station using the given UTC timestamp.</div></div>",3930:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3930\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual void</span> disableBeacon()</div><div class=\"TTSummary\">Disables the beacon on the base station.</div></div>",3931:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3931\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">virtual</span> BeaconStatus beaconStatus()</div><div class=\"TTSummary\">Gets the BeaconStatus of the beacon on the BaseStation.</div></div>",3932:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3932\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual void</span> startRfSweepMode(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint32</span>&nbsp;</td><td class=\"PName last\">minFreq,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint32</span>&nbsp;</td><td class=\"PName last\">maxFreq,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint32</span>&nbsp;</td><td class=\"PName last\">interval,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">options</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Starts the BaseStation in RF Sweep Mode.</div></div>",3933:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3933\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">void</span> cyclePower()</div><div class=\"TTSummary\">Cycles the power on the base station.</div></div>",3934:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3934\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">void</span> resetRadio()</div><div class=\"TTSummary\">Resets the radio on the base station.</div></div>",3935:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3935\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> changeFrequency(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">WirelessTypes::</td><td class=\"PType\">Frequency&nbsp;</td><td class=\"PName last\">frequency</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Changes the radio frequency of the base station.</div></div>",3936:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3936\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> verifyConfig(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">BaseStationConfig&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">config,</td></tr><tr><td class=\"first\"></td><td class=\"PType\">ConfigIssues&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">outIssues</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Checks whether the settings in the given BaseStationConfig are ok to be written to the BaseStation.&nbsp; Options that are set will also be validated against each other. If an option that needs to be validated isn\'t currently set, it will be read from the BaseStation.</div></div>",3937:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3937\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">void</span> applyConfig(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">BaseStationConfig&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">config</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Applies a BaseStationConfig to the Node.</div></div>",3938:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3938\" class=\"NDPrototype NoParameterForm\">WirelessTypes::TransmitPower getTransmitPower() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the WirelessTypes::TransmitPower that is currently set on the BaseStation.</div></div>",3939:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3939\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">BaseStationButton getButtonLongPress(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint8</span>&nbsp;</td><td class=\"PName last\">buttonNumber</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Gets the current button settings for a long press action, as a BaseStationButton.</div></div>",3940:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3940\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">BaseStationButton getButtonShortPress(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint8</span>&nbsp;</td><td class=\"PName last\">buttonNumber</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Gets the current button settings for a short press action, as a BaseStationButton.</div></div>",3941:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3941\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">bool</span> getAnalogPairingEnabled() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Gets the current setting for if Analog Pairing is enabled or not.</div></div>",3942:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3942\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">uint16</span> getAnalogTimeoutTime() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the Analog Timeout Time in seconds that is currently set on the BaseStation.</div></div>",3943:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3943\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">float</span> getAnalogTimeoutVoltage() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the Analog Timeout Voltage that is currently set on the BaseStation.</div></div>",3944:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3944\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">bool</span> getAnalogExceedanceEnabled() <span class=\"SHKeyword\">const</span></div><div class=\"TTSummary\">Reads the Analog Exceedance enabled/disabled setting that is currently set on the BaseStation.</div></div>",3945:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3945\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">BaseStationAnalogPair getAnalogPair(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint8</span>&nbsp;</td><td class=\"PName last\">portNumber</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">const</span></td></tr></table></div><div class=\"TTSummary\">Reads the BaseStationAnalogPair for the specified port number that is currently set on the BaseStation.</div></div>",3946:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3946\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">bool</span> ping_v1()</div><div class=\"TTSummary\">Performs version 1 of the Ping BaseStation command.</div></div>",3947:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3947\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">bool</span> ping_v2()</div><div class=\"TTSummary\">Performs version 2 of the Ping BaseStation command.</div></div>",3948:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3948\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> read_v1(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td></td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">result</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs version 1 of the Read BaseStation EEPROM command.</div></div>",3949:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3949\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> read_v2(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td></td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">result</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs version 2 of the Read BaseStation EEPROM command.</div></div>",3950:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3950\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> write_v1(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">value</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs version 1 of the Write BaseStation EEPROM command.</div></div>",3951:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3951\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> write_v2(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">value</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs version 2 of the Write BaseStation EEPROM command.</div></div>",3952:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3952\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">Timestamp enableBeacon_v1(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint32</span>&nbsp;</td><td class=\"PName last\">utcTime</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs version 1 of the Enable Beacon command.</div></div>",3953:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3953\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">Timestamp enableBeacon_v2(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint32</span>&nbsp;</td><td class=\"PName last\">utcTime</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs version 2 of the Enable Beacon command.</div></div>",3954:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3954\" class=\"NDPrototype NoParameterForm\">BeaconStatus beaconStatus_v1()</div><div class=\"TTSummary\">Performs version 1 of the Beacon Status command.</div></div>",3955:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3955\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> node_pageDownload_v1(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td></td><td class=\"PName last\">pageIndex,</td></tr><tr><td class=\"PType first\">ByteStream&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">data</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs Version 1 of the Node Page Download command.</div></div>",3956:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3956\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> node_shortPing_v1(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td class=\"PName last\">nodeAddress</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs Version 1 of the Node Short Ping command.</div></div>",3957:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3957\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> node_shortPing_v2(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td class=\"PName last\">nodeAddress</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs Version 2 of the Node Short Ping command.</div></div>",3958:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3958\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> node_readEeprom_v1(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td></td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">eepromValue</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs Version 1 of the Node Read Eeprom command.</div></div>",3959:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3959\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> node_readEeprom_v2(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td></td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">eepromValue</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs Version 2 of the Node Read Eeprom command.</div></div>",3960:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3960\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> node_writeEeprom_v1(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">value</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs Version 1 of the Node Write Eeprom command.</div></div>",3961:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3961\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> node_writeEeprom_v2(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">value</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs Version 2 of the Node Write Eeprom command.</div></div>",3962:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3962\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> node_autoBalance_v1(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint8</span>&nbsp;</td><td></td><td class=\"PName last\">channelNumber,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">float</span>&nbsp;</td><td></td><td class=\"PName last\">targetPercent,</td></tr><tr><td class=\"PType first\">AutoBalanceResult&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">result</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs Version 1 of the Node AutoBalance command.</div></div>",3963:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3963\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> node_autoBalance_v2(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint8</span>&nbsp;</td><td></td><td class=\"PName last\">channelNumber,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">float</span>&nbsp;</td><td></td><td class=\"PName last\">targetPercent,</td></tr><tr><td class=\"PType first\">AutoBalanceResult&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">result</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs Version 2 of the Node AutoBalance command.</div></div>",3964:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3964\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">const</span> Timestamp&amp; node_lastCommunicationTime(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td class=\"PName last\">nodeAddress</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Gets the Timestamp for the last time MSCL communicated with the given node address.</div></div>",3965:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3965\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual</span> PingResponse node_ping(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td class=\"PName last\">nodeAddress</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Pings the specified Node.</div></div>",3966:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3966\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual bool</span> node_sleep(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td class=\"PName last\">nodeAddress</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Puts the Node into a low power, sleep mode.&nbsp; This command attempts to ping the node before sending the sleep command, to verify communication.</div></div>",3967:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3967\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual</span> SetToIdleStatus node_setToIdle(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"first\"></td><td class=\"PType\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">BaseStation&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">base</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Attempts to set the node to idle so that it can be communicated with.</div></div>",3968:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3968\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> node_shortPing(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td class=\"PName last\">nodeAddress</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Pings a specific node.</div></div>",3969:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3969\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual bool</span> node_readEeprom(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">WirelessProtocol&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">nodeProtocol,</td></tr><tr><td class=\"first\"></td><td class=\"PType\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td></td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">eepromValue</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Reads a value from EEPROM on the specified Node.</div></div>",3970:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3970\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual bool</span> node_writeEeprom(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">WirelessProtocol&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">nodeProtocol,</td></tr><tr><td class=\"first\"></td><td class=\"PType\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td></td><td class=\"PName last\">eepromAddress,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td></td><td class=\"PName last\">value</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Writes a value to EEPROM on the specified Node.</div></div>",3971:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3971\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual bool</span> node_pageDownload(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">WirelessProtocol&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">nodeProtocol,</td></tr><tr><td class=\"first\"></td><td class=\"PType\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td></td><td class=\"PName last\">pageIndex,</td></tr><tr><td class=\"first\"></td><td class=\"PType\">ByteStream&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">data</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Download a page of logged data from the Node</div></div>",3972:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3972\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual bool</span> node_startSyncSampling(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td class=\"PName last\">nodeAddress</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sends the Start Synchronized Sampling command to a Node.</div></div>",3973:"<div class=\"NDToolTip TFunction LC\"><div class=\"TTSummary\">Sends the Start Non-Synchronized Sampling command to a Node.</div></div>",3974:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3974\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual bool</span> node_armForDatalogging(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"first\"></td><td class=\"PType\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span> std::</td><td class=\"PType\"><span class=\"SHKeyword\">string</span>&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">message</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sends the Arm For Datalogging command to a Node.</div></div>",3975:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3975\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual void</span> node_triggerArmedDatalogging(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td class=\"PName last\">nodeAddress</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sends the Trigger Armed Datalogging command to a Node.</div></div>",3976:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3976\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual bool</span> node_erase(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td class=\"PName last\">nodeAddress</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sends the Erase command to a Node.</div></div>",3977:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3977\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual bool</span> node_autoBalance(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">WirelessProtocol&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">nodeProtocol,</td></tr><tr><td class=\"first\"></td><td class=\"PType\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">uint8</span>&nbsp;</td><td></td><td class=\"PName last\">channelNumber,</td></tr><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">float</span>&nbsp;</td><td></td><td class=\"PName last\">targetPercent,</td></tr><tr><td class=\"first\"></td><td class=\"PType\">AutoBalanceResult&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">result</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Sends the AutoBalance command to a Node.</div></div>",3978:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3978\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> node_autocal(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"first\"></td><td class=\"PType\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"PModifierQualifier first\">WirelessModels::</td><td class=\"PType\">NodeModel&nbsp;</td><td></td><td class=\"PName last\">model,</td></tr><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">Version&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">fwVersion,</td></tr><tr><td class=\"first\"></td><td class=\"PType\">AutoCalResult&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">result</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Performs automatic calibration for a Wireless Node.</div></div>",3979:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype3979\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> node_readSingleSensor(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\">NodeAddress&nbsp;</td><td></td><td class=\"PName last\">nodeAddress,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint8</span>&nbsp;</td><td></td><td class=\"PName last\">channelNumber,</td></tr><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">result</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Reads the bits value for a single channel on a Wireless Node.</div></div>"});