NDSummary.OnToolTipsLoaded("File:MicroStrain/Wireless/Commands/BaseStation_BeaconStatus.h",{1624:"<div class=\"NDToolTip TClass LC\"><div class=\"NDClassPrototype\" id=\"NDClassPrototype1624\"><div class=\"CPEntry TClass Current\"><div class=\"CPName\">BeaconStatus</div></div></div><div class=\"TTSummary\">Represents the status of a BaseStation beacon.&nbsp; See also BaseStation::beaconStatus.</div></div>",1626:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1626\" class=\"NDPrototype NoParameterForm\">BeaconStatus()</div><div class=\"TTSummary\">Creates a default BeaconStatus object.</div></div>",1627:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1627\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">BeaconStatus(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"first\"></td><td class=\"PType\"><span class=\"SHKeyword\">bool</span>&nbsp;</td><td></td><td class=\"PName last\">beaconEnabled,</td></tr><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">Timestamp&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">currentTimestamp</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Creates a BeaconStatus object with the given parameters.</div></div>",1629:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1629\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">bool</span> m_enabled</div><div class=\"TTSummary\">Whether the beacon is enabled or disabled.</div></div>",1630:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1630\" class=\"NDPrototype NoParameterForm\">Timestamp m_timestamp</div><div class=\"TTSummary\">The current Timestamp of the beacon.</div></div>",1632:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1632\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">bool</span> enabled()</div><div class=\"TTSummary\">Gets whether the beacon is enabled (true) or disabled (false).</div></div>",1633:"<div class=\"NDToolTip TFunction LC\"><div class=\"TTSummary\">Gets the current Timestamp of the beacon.</div></div>",1634:"<div class=\"NDToolTip TClass LC\"><div class=\"NDClassPrototype\" id=\"NDClassPrototype1634\"><div class=\"CPEntry TClass Current\"><div class=\"CPName\">BaseStation_BeaconStatus</div></div></div><div class=\"TTSummary\">Contains logic for the base station Get Beacon Status command.</div></div>",1636:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1636\" class=\"NDPrototype NoParameterForm\"><span class=\"SHKeyword\">static</span> ByteStream buildCommand()</div><div class=\"TTSummary\">Builds the beacon status command.</div></div>",1637:"<div class=\"NDToolTip TClass LC\"><div class=\"NDClassPrototype\" id=\"NDClassPrototype1637\"><div class=\"CPEntry TClass Current\"><div class=\"CPName\">Response</div></div></div><div class=\"TTSummary\">Handles the response to the command</div></div>",1639:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1639\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\">Response(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\">std::</td><td class=\"PType\">weak_ptr&lt;ResponseCollector&gt;&nbsp;</td><td class=\"PName last\">collector</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Creates a get beacon status Response object</div></div>",1641:"<div class=\"NDToolTip TVariable LC\"><div id=\"NDPrototype1641\" class=\"NDPrototype NoParameterForm\">BeaconStatus m_result</div><div class=\"TTSummary\">The BeaconStatus that holds the result of the command.</div></div>",1643:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1643\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">virtual bool</span> match(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">WirelessPacket&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">packet</td></tr></table></td><td class=\"PAfterParameters\">) <span class=\"SHKeyword\">override</span></td></tr></table></div><div class=\"TTSummary\">Checks if the packet passed in matches either the success or failure response.</div></div>",1644:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1644\" class=\"NDPrototype NoParameterForm\">BeaconStatus result()</div><div class=\"TTSummary\">Gets the BeaconStatus that holds the result of the response.</div></div>",1645:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1645\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> matchSuccessResponse(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">WirelessPacket&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">packet</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Checks if the packet passed in matches the success response.</div></div>",1646:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1646\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">bool</span> matchFailResponse(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">WirelessPacket&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">packet</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Checks if the packet passed in matches the failure response.</div></div>"});