NDSummary.OnToolTipsLoaded("File:MicroStrain/Wireless/Configuration/NodeEepromMap.h",{1851:"<div class=\"NDToolTip TClass LC\"><div class=\"NDClassPrototype\" id=\"NDClassPrototype1851\"><div class=\"CPEntry TClass Current\"><div class=\"CPName\">NodeEepromMap</div></div></div><div class=\"TTSummary\">Contains information on every EEPROM available on Wireless Nodes</div></div>",1853:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1853\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">static bool</span> canUseCache_read(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">eepromLocation</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Gets whether or not the specified eeprom location can use the eeprom cache for reading, or should always be read from the Node.</div></div>",1854:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1854\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">static bool</span> canUseCache_write(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PType first\"><span class=\"SHKeyword\">uint16</span>&nbsp;</td><td class=\"PName last\">eepromLocation</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Gets whether or not the specified eeprom location can use the eeprom cache for writing, or should always be written to the Node.</div></div>",1855:"<div class=\"NDToolTip TFunction LC\"><div id=\"NDPrototype1855\" class=\"NDPrototype WideForm CStyle\"><table><tr><td class=\"PBeforeParameters\"><span class=\"SHKeyword\">static</span> EepromLocation getOffsetEeprom(</td><td class=\"PParametersParentCell\"><table class=\"PParameters\"><tr><td class=\"PModifierQualifier first\"><span class=\"SHKeyword\">const</span>&nbsp;</td><td class=\"PType\">EepromLocation&nbsp;</td><td class=\"PNamePrefix\">&amp;</td><td class=\"PName last\">slopeEeprom</td></tr></table></td><td class=\"PAfterParameters\">)</td></tr></table></div><div class=\"TTSummary\">Finds the offset EepromLocation that goes with the given slope EepromLocation.</div></div>",1857:"<div class=\"NDToolTip TConstant LC\"><div class=\"TTSummary\">CURRENT_LOG_PAGE&nbsp; -The next flash page to be used for datalogging CURRENT_PAGE_OFFSET&nbsp; -The byte offset location for the next datalogging session DATA_SETS_STORED&nbsp; -The # of datalogging sessions (triggers) stored in flash memory ACTIVE_CHANNEL_MASK&nbsp; -The channels that are enabled/disabled and will be sampled DATALOG_SAMPLE_RATE&nbsp; -The sample rate for Armed Datalogging sampling NUM_SWEEPS&nbsp; -The # of sweeps (samples per data set) to sample for DEFAULT_MODE&nbsp; -The default mode to allow the node to perform different operations on startup and after timeout SERIAL_ID&nbsp; -The serial ID for the node. Combine with the model number for the full serial number SAMPLING_MODE&nbsp; -The sampling mode of the node (Sync Sampling, Non-Sync Sampling, Armed Datalogging, etc.)&nbsp; HW_OFFSET_1&nbsp; -The hardware offset of channel 1 HW_OFFSET_2&nbsp; -The hardware offset of channel 2 HW_OFFSET_3&nbsp; -The hardware offset of channel 3 HW_OFFSET_4&nbsp; -The hardware offset of channel 4 HW_OFFSET_5&nbsp; -The hardware offset of channel 5 HW_OFFSET_6&nbsp; -The hardware offset of channel 6 HW_OFFSET_7&nbsp; -The hardware offset of channel 7 HW_OFFSET_8&nbsp; -The hardware offset of channel 8 SAMPLING_DELAY&nbsp; -The sampling delay (amount of time between sensor excitation power up and A/D sampling TDMA_ADDRESS&nbsp; -The TDMA network address used for Synchronized Sampling COLLECTION_MODE&nbsp; -The data collection mode (log, transmit) that affects standard sampling modes NUM_BUFF_PACKETS&nbsp; -The # of buffered packets NUM_RETRAN_ATTEMPTS&nbsp; -The # of retransmit attempts NODE_ADDRESS&nbsp; -The node address of the wireless node SLEEP_INTERVAL&nbsp; -The listen-for-wakeup interval for the node INACTIVE_TIMEOUT&nbsp; -The length of time necessary before a node enters sleep mode, if no user activity SAMPLE_RATE&nbsp; -The sample rate for standard sampling modes (Synchronized Sampling, LDC) DATA_FORMAT&nbsp; -The packet format (uint16, float, etc.) of sampled data SNIFF_DURATION&nbsp; -The amount of time that the node listens for a wake packets FREQUENCY&nbsp; -The radio frequency channel TX_POWER_LEVEL&nbsp; -The transmit output power of the radio UNLIMITED_SAMPLING&nbsp; -The unlimited sampling flag for standard sampling modes UNLIMITED_DATALOG&nbsp; -The unlimited sampling flag for Armed Datalogging sampling FIRMWARE_VER&nbsp; -The firmware version of the node (part 1) FIRMWARE_VER2&nbsp; -The firmware version of the node (part 2) MODEL_NUMBER&nbsp; -The model number of the node MODEL_OPTION&nbsp; -The model option of the node LEGACY_MODEL_NUMBER&nbsp; -The (legacy) model number of the node LEGACY_SERIAL_ID&nbsp; -The (legacy) serial ID for the node. Combine with the model number for the full serial number MAX_MEMORY&nbsp; -The maximum number of pages available on the flash memory MICROCONTROLLER&nbsp; -The ID of the microcontroller FW_ARCH_VER&nbsp; -The firmware architecture version HW_GAIN_1&nbsp; -The hardware gain of channel 1 HW_GAIN_2&nbsp; -The hardware gain of channel 2 HW_GAIN_3&nbsp; -The hardware gain of channel 3 HW_GAIN_4&nbsp; -The hardware gain of channel 4 HW_GAIN_5&nbsp; -The hardware gain of channel 5 HW_GAIN_6&nbsp; -The hardware gain of channel 6 HW_GAIN_7&nbsp; -The hardware gain of channel 7 HW_GAIN_8&nbsp; -The hardware gain of channel 8 CH_ACTION_ID_1&nbsp; -The channel action ID of channel 1 CH_ACTION_SLOPE_1&nbsp; -The channel action slope of channel 1 CH_ACTION_OFFSET_1&nbsp; -The channel action offset of channel 1 CH_ACTION_ID_2&nbsp; -The channel action ID of channel 2 CH_ACTION_SLOPE_2&nbsp; -The channel action slope of channel 2 CH_ACTION_OFFSET_2&nbsp; -The channel action offset of channel 2 CH_ACTION_ID_3&nbsp; -The channel action ID of channel 3 CH_ACTION_SLOPE_3&nbsp; -The channel action slope of channel 3 CH_ACTION_OFFSET_3&nbsp; -The channel action offset of channel 3 CH_ACTION_ID_4&nbsp; -The channel action ID of channel 4 CH_ACTION_SLOPE_4&nbsp; -The channel action slope of channel 4 CH_ACTION_OFFSET_4&nbsp; -The channel action offset of channel 4 CH_ACTION_ID_5&nbsp; -The channel action ID of channel 5 CH_ACTION_SLOPE_5&nbsp; -The channel action slope of channel 5 CH_ACTION_OFFSET_5&nbsp; -The channel action offset of channel 5 CH_ACTION_ID_6&nbsp; -The channel action ID of channel 6 CH_ACTION_SLOPE_6&nbsp; -The channel action slope of channel 6 CH_ACTION_OFFSET_6&nbsp; -The channel action offset of channel 6 CH_ACTION_ID_7&nbsp; -The channel action ID of channel 7 CH_ACTION_SLOPE_7&nbsp; -The channel action slope of channel 7 CH_ACTION_OFFSET_7&nbsp; -The channel action offset of channel 7 CH_ACTION_ID_8&nbsp; -The channel action ID of channel 8 CH_ACTION_SLOPE_8&nbsp; -The channel action slope of channel 8 CH_ACTION_OFFSET_8&nbsp; -The channel action offset of channel 8 BOOTLOADER_VER&nbsp; -The bootloader version number RESET_COUNTER&nbsp; -The number of times the node has been turned on CYCLE_POWER&nbsp; -Used to soft reset the node or the radio on the node RADIO_OPTIONS&nbsp; -The options of the current radio (XR enabled or not, etc.)&nbsp; LOST_BEACON_TIMEOUT&nbsp; -The time for a node to wait before entering a low power state when no longer hearing a beacon in Sync Sampling SYNC_SAMPLE_SETTING&nbsp; -The Synchronized Sampling mode (Burst, Continuous, etc.)&nbsp; TX_PER_GROUP&nbsp; -The transmissions per group for Synchronized Sampling GROUP_SIZE&nbsp; -The group size for Synchronized Sampling TIME_BETW_SESSIONS&nbsp; -The time between each burst for Synchronized Sampling NODE_RETRANSMIT&nbsp; -Node retranmission enable/disable (for Lossless) MAX_RETRANS_PACKET&nbsp; -The max retransmits per packet MAX_RETRANS_BURST&nbsp; -The max retransmits per burst REGION_CODE&nbsp; -The region code for the device DATA_PACKET_FORMAT&nbsp; -The format of the data packet that will be sent out.&nbsp; EVENT_SAMPLE_RATE&nbsp; -Event Driven Sampling: Sample Rate EVENT_CHANNEL_MASK&nbsp; -Event Driven Sampling: Channel Mask EVENT_PRE_DURATION&nbsp; -Event Driven Sampling: Pre-Event Duration EVENT_POST_DURATION&nbsp; -Event Driven Sampling: Post-Event Duration EVENT_SRC_1&nbsp; -Event Driven Sampling: The source for Event 1 EVENT_OPER_1&nbsp; -Event Driven Sampling: The operation for Event 1 EVENT_VAL1_1&nbsp; -Event Driven Sampling: Value 1 for Event 1 EVENT_VAL2_1&nbsp; -Event Driven Sampling: Value 2 for Event 1 EVENT_SRC_2&nbsp; -Event Driven Sampling: The source for Event 2 EVENT_OPER_2&nbsp; -Event Driven Sampling: The operation for Event 2 EVENT_VAL1_2&nbsp; -Event Driven Sampling: Value 1 for Event 2 EVENT_VAL2_2&nbsp; -Event Driven Sampling: Value 2 for Event 2 EVENT_SRC_3&nbsp; -Event Driven Sampling: The source for Event 3 EVENT_OPER_3&nbsp; -Event Driven Sampling: The operation for Event 3 EVENT_VAL1_3&nbsp; -Event Driven Sampling: Value 1 for Event 3 EVENT_VAL2_3&nbsp; -Event Driven Sampling: Value 2 for Event 3 EVENT_SRC_4&nbsp; -Event Driven Sampling: The source for Event 4 EVENT_OPER_4&nbsp; -Event Driven Sampling: The operation for Event 4 EVENT_VAL1_4&nbsp; -Event Driven Sampling: Value 1 for Event 4 EVENT_VAL2_4&nbsp; -Event Driven Sampling: Value 2 for Event 4 EVENT_SRC_5&nbsp; -Event Driven Sampling: The source for Event 5 EVENT_OPER_5&nbsp; -Event Driven Sampling: The operation for Event 5 EVENT_VAL1_5&nbsp; -Event Driven Sampling: Value 1 for Event 5 EVENT_VAL2_5&nbsp; -Event Driven Sampling: Value 2 for Event 5 EVENT_SRC_6&nbsp; -Event Driven Sampling: The source for Event 6 EVENT_OPER_6&nbsp; -Event Driven Sampling: The operation for Event 6 EVENT_VAL1_6&nbsp; -Event Driven Sampling: Value 1 for Event 6 EVENT_VAL2_6&nbsp; -Event Driven Sampling: Value 2 for Event 6 EVENT_SRC_7&nbsp; -Event Driven Sampling: The source for Event 7 EVENT_OPER_7&nbsp; -Event Driven Sampling: The operation for Event 7 EVENT_VAL1_7&nbsp; -Event Driven Sampling: Value 1 for Event 7 EVENT_VAL2_7&nbsp; -Event Driven Sampling: Value 2 for Event 7 EVENT_SRC_8&nbsp; -Event Driven Sampling: The source for Event 8 EVENT_OPER_8&nbsp; -Event Driven Sampling: The operation for Event 8 EVENT_VAL1_8&nbsp; -Event Driven Sampling: Value 1 for Event 8 EVENT_VAL2_8&nbsp; -Event Driven Sampling: Value 2 for Event 8 CHANNEL_FILTER&nbsp; -The channel filter for all channels MIN_SOFT_VER_MAJOR&nbsp; -The minimum software version for support of this device (major) MIN_SOFT_VER_MINOR&nbsp; -The minimum software version for support of this device (minor) GAUGE_FACTOR_1&nbsp; -The Gauge Factor (1) GAUGE_FACTOR_2&nbsp; -The Gauge Factor (2) GAUGE_FACTOR_3&nbsp; -The Gauge Factor (3) GAUGE_FACTOR_4&nbsp; -The Gauge Factor (4)</div></div>"});